#ifndef ASMSELECT_H_
#define ASMSELECT_H_

#ifdef __cplusplus
extern "C" {
#endif

#if	defined(HAVE_HOST_CPU_FAMILY_x86) &&	\
	!defined(HAVE_HOST_CPU_FAMILY_x86_64)

#define	MUL1(r,s1,s2)	MUL1__c0(r,s1,s2)
#define	MUL2(r,s1,s2)	MUL2__k0(r,s1,s2)
#define	MUL3(r,s1,s2)	MUL3__k0(r,s1,s2)
#define	MUL4(r,s1,s2)	MUL4__k0(r,s1,s2)
#define	MUL5(r,s1,s2)	MUL5__x86_inter_2(r,s1,s2)
#define	MUL6(r,s1,s2)	MUL6__x86_inter_0(r,s1,s2)
#define	MUL7(r,s1,s2)	MUL7__x86_inter_0(r,s1,s2)
#define	MUL8(r,s1,s2)	MUL8__x86_inter_0(r,s1,s2)

#define	ADDMUL1(r,s1,s2)	ADDMUL1__c0(r,s1,s2)
#define	ADDMUL2(r,s1,s2)	ADDMUL2__k0(r,s1,s2)
#define	ADDMUL3(r,s1,s2)	ADDMUL3__k0(r,s1,s2)
#define	ADDMUL4(r,s1,s2)	ADDMUL4__k0(r,s1,s2)

#define	SQR1(t,s)	SQR1__c0(t,s)
#define	SQR2(t,s)	SQR2__k0(t,s)
#define	SQR3(t,s)	SQR3__k0(t,s)
#define	SQR4(t,s)	SQR4__k0(t,s)

#define	SQR1c(t,s)	SQR1c__k0(t,s)
#define	SQR2c(t,s)	SQR2c__k0(t,s)
#define	SQR3c(t,s)	SQR3c__k0(t,s)
#define	SQR4c(t,s)	SQR4c__x86_1(t,s)

#elif	defined(HAVE_HOST_CPU_FAMILY_x86_64)

#define	MUL1(r,s1,s2)	MUL1__c0(r,s1,s2)
#define	MUL2(r,s1,s2)	MUL2__fullc(r,s1,s2)
#define	MUL3(r,s1,s2)	MUL3__fullc(r,s1,s2)
#define	MUL4(r,s1,s2)	MUL4__fullc(r,s1,s2)
#define	MUL5(r,s1,s2)	MUL5__fullc(r,s1,s2)
#define	MUL6(r,s1,s2)	MUL6__fullc(r,s1,s2)
#define	MUL7(r,s1,s2)	MUL7__fullc(r,s1,s2)
#define	MUL8(r,s1,s2)	MUL8__fullc(r,s1,s2)

#define	ADDMUL1(r,s1,s2)	ADDMUL1__c0(r,s1,s2)
#define	ADDMUL2(r,s1,s2)	ADDMUL2__fullc(r,s1,s2)
#define	ADDMUL3(r,s1,s2)	ADDMUL3__fullc(r,s1,s2)
#define	ADDMUL4(r,s1,s2)	ADDMUL4__fullc(r,s1,s2)

#define	SQR1(t,s)	SQR1__c0(t,s)
#define	SQR2(t,s)	SQR2__fullc(t,s)
#define	SQR3(t,s)	SQR3__fullc(t,s)
#define	SQR4(t,s)	SQR4__fullc(t,s)

#define	SQR1c(t,s)	SQR1c__fullc(t,s)
#define	SQR2c(t,s)	SQR2c__fullc(t,s)
#define	SQR3c(t,s)	SQR3c__fullc(t,s)
#define	SQR4c(t,s)	SQR4c__fullc(t,s)

#endif

#ifdef __cplusplus
}
#endif

#endif	/* ASMSELECT_H_ */
