/* $Id: rf_layer_prime.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */


#include <stdlib.h>
#include <string.h>
#include <gmp.h>

#ifdef	HAVE_CONFIG_H 
#include <config.h>
#endif

#include "mploc.h"

#include "field_def.h"
#include "field_prime.h"
#include "rf_layer_prime.h"

#include "gmp_hacks.h"

rf_elt new_rfe(mplf_t f)
{
	return malloc(RF(f)->size * sizeof(mp_limb_t));
}

void _delete_rfe(rf_elt * e, mplf_t f)
{
	free(*e);
	*e=NULL;
}

void rfe_set_mploc(rf_elt e, mploc_srcptr x, mplf_t f)
{
	RF(f)->set_mpz(e,x->x,RF(f));
}

void mploc_set_rfe(mploc_ptr x, rf_elt e, mplf_t f)
{
	MPZ_SET_MPN(x->x,e,RF(f)->size);
	x->prec=1;
}


